#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <allegro.h>
#include "defs.h"
#include "bump.h"
#include "data1.h"


void bump_map();
void init_bump_mapping();
void draw_bump_map();
void init_maps();
void bump(int focx, int focy);
void move_focus();
void initialise_allegro();

void initialise_allegro()
{ 
 allegro_init(); 
 set_gfx_mode(GFX_AUTODETECT, 320, 200, 0, 0);  
 buffer1=create_bitmap(320,200);
 set_palette(pal); 
 install_keyboard();
 install_timer();
 data=load_datafile("data1.dat");
}


void bump_map()
{
 init_maps();
 init_bump_mapping();
 focx=160;
 focy=100;
 focdeltax=5;
 focdeltay=-5;
 while(!key[KEY_ESC])
 { 
  bump(focx, focy);  
  draw_bump_map();
  move_focus();
 } 
}


void init_bump_mapping()
{
 set_gfx_mode(GFX_AUTODETECT, 320, 200, 0, 0);
 set_pallete(data[pal1].dat);
 blit(data[hmap1].dat,buffer1,0,0,0,0,320,200);
 memcpy(hmap, buffer1->line[0],64000);
}

void draw_bump_map()
{
 memcpy(buffer1->line[0], dbuffer, 64000); 
 vsync();
 blit(buffer1,screen,0,0,0,0,320,200);
}

void init_maps()
{
   float nX,nY,nZ;
   int x,y;
   for (y=0;y<256;y++)
   for (x=0;x<256;x++)
   {
      nX=(x-128)/128.0;
      nY=(y-128)/128.0;
      nZ=1-sqrt(nX*nX+nY*nY);
      if (nZ<0) nZ=0;
      litemap[x+y*256]=nZ*256;
   }
}



void bump(int hvx, int hvy)
{
   int nx,ny;
   int rx,ry;
   int i=320*1;
   int x,y;

   for (y=1;y<198;y++)
   for (x=0;x<320;x++)
   {
      nx=hmap[i+1]-hmap[i-1];
      ny=hmap[i+320]-hmap[i-320];

      rx=x - hvx;
      ry=y - hvy;

      nx-=rx;
      ny-=ry;

      nx+=128;
      ny+=128;
      if (nx>255 || nx<0) nx=255;
      if (ny>255 || ny<0) ny=255;
      dbuffer[i]=litemap[nx+ny*256];
      i++;
   }
}

void move_focus()
{
 focx+=focdeltax;
 focy+=focdeltay;
 if (focx<10) focdeltax=+5;
 if (focx>310) focdeltax=-5;
 if (focy<10) focdeltay=+5;
 if (focy>190) focdeltay=-5;
}

void main()
{
    initialise_allegro();
    bump_map();
    exit(0);
}
